IMPLEMENTATION MODULE Configuration;


   (*$S-,$T- turn off stack and range checking *) 

   FROM SYSTEM IMPORT TSIZE, ADR;
   IMPORT GEMDOS;
   IMPORT Text;


   CONST
      StandardDrive           = "A:\*.*";
      StandardApptFileName    = "A:\APPT.DAT";
      StandardPhoneFileName   = "A:\PHONE.DAT";
      StandardLogFileName     = "A:\LOG.DAT";
      StandardNoteDirectory   = "A:";

   (************************** LOCAL ROUTINE ***************************)

   PROCEDURE InRange ( Ch : CHAR ) : BOOLEAN;

   BEGIN
      RETURN ((Ch >= 'A') AND (Ch <= 'Z'));
   END InRange;

   (************************** LOCAL ROUTINE ***************************)

   PROCEDURE GetString (
      VAR FileId : (* IN  *) INTEGER;
      VAR String : (* OUT *) ARRAY OF CHAR ) : INTEGER;

   CONST
      CR = 15C;
      LF = 12C;

   VAR
      FileStatus : INTEGER; 
      Count      : LONGCARD;
      Index      : CARDINAL;
      Ch         : CHAR;
      FoundCh    : BOOLEAN;

   BEGIN
      FileStatus := GEMDOS.EOK;
      Count      := LONGCARD (TSIZE (CHAR));
      Index      := 0;
      FoundCh    := FALSE;
      LOOP
         GEMDOS.Read ( FileId, Count, ADR (Ch) );
         IF Count <> LONGCARD (TSIZE (CHAR)) THEN
            FileStatus := GEMDOS.EReadF;
            EXIT;
         ELSIF String[Index] = LF THEN
            String[Index] := CHR (0);
            EXIT;
         ELSIF (Ch = ' ') AND (NOT FoundCh) THEN
            (* Ignore leading blanks *)
         ELSIF ((Ch = ' ') AND FoundCh) OR (Ch = CR) THEN
            String[Index] := CHR (0);
            LOOP
               GEMDOS.Read ( FileId, Count, ADR (Ch) );
               IF Count <> LONGCARD (TSIZE (CHAR)) THEN
                  FileStatus := GEMDOS.EReadF;
                  EXIT;
               ELSIF Ch = LF THEN
                  EXIT;
               END;
            END (* LOOP *);
            EXIT;
         ELSIF Index < HIGH (String) THEN
            String[Index] := Ch;
            INC (Index);
            FoundCh := TRUE;
         END;
      END (* LOOP *);
      RETURN (FileStatus);
   END GetString;

   (********************************************************************)

   PROCEDURE LoadDefault ();

   CONST Read = 0;

   VAR
      FileStatus : INTEGER;
      FileId     : INTEGER;
      Success    : BOOLEAN;

   BEGIN
      DefaultDrive       := StandardDrive;
      MonochromeResource := "A:\RESOURCE\DESKPAKM.RSC";
      ColorResource      := "A:\RESOURCE\DESKPAKC.RSC";
      ApptFileName       := StandardApptFileName;
      PhoneFileName      := StandardPhoneFileName;
      LogFileName        := StandardLogFileName;
      NoteFileName       := StandardNoteDirectory;
      ModemDialPrefix    := "ATDT";
      ModemDialSuffix    := ";H0";
      ShowTime           := "YES";
      GEMDOS.Open ( "C:\DESKPAC.CFG", Read, FileId );
      IF FileId < GEMDOS.EOK THEN
         GEMDOS.Open ( "A:\DESKPAC.CFG", Read, FileId );
      END;
      IF FileId < GEMDOS.EOK THEN
         FileStatus := FileId;
      ELSE
         FileStatus := GetString ( FileId, DefaultDrive );
         IF FileStatus = GEMDOS.EOK THEN
            Text.UpperCase ( DefaultDrive );
            IF NOT (
               InRange ( DefaultDrive[0] ) AND
               (DefaultDrive[1] = ':')) THEN
                  DefaultDrive := StandardDrive;
            END;
            FileStatus := GetString ( FileId, MonochromeResource );
         END;
         IF FileStatus = GEMDOS.EOK THEN
            FileStatus := GetString ( FileId, ColorResource );
         END;
         IF FileStatus = GEMDOS.EOK THEN
            FileStatus := GetString ( FileId, ApptFileName );
         END;
         IF FileStatus = GEMDOS.EOK THEN
            Text.UpperCase ( ApptFileName );
            IF NOT InRange ( ApptFileName[0] ) THEN
               ApptFileName := StandardApptFileName;
            END;
            FileStatus := GetString ( FileId, PhoneFileName );
         END;
         IF FileStatus = GEMDOS.EOK THEN
            Text.UpperCase ( PhoneFileName );
            IF NOT InRange ( PhoneFileName[0] ) THEN
               PhoneFileName := StandardPhoneFileName;
            END;
            FileStatus := GetString ( FileId, LogFileName );
         END;
         IF FileStatus = GEMDOS.EOK THEN
            Text.UpperCase ( LogFileName );
            IF NOT InRange ( LogFileName[0] ) THEN
               LogFileName := StandardLogFileName;
            END;
            FileStatus := GetString ( FileId, NoteFileName );
         END;
         IF FileStatus = GEMDOS.EOK THEN
            Text.UpperCase ( NoteFileName );
            IF NOT InRange ( NoteFileName[0] ) THEN
               NoteFileName := StandardNoteDirectory;
            END;
            FileStatus := GetString ( FileId, ModemDialPrefix );
         END;
         IF FileStatus = GEMDOS.EOK THEN
            FileStatus := GetString ( FileId, ModemDialSuffix );
         END;
         IF FileStatus = GEMDOS.EOK THEN
            FileStatus := GetString ( FileId, ShowTime );
         END;
         Success := GEMDOS.Close ( FileId );
      END;
   END LoadDefault;


END Configuration.

