MODULE DeskPac;


FROM SYSTEM IMPORT SETREG, ADR;
IMPORT GEMAESbase;
IMPORT GEMDOS;
IMPORT AESApplications;
IMPORT AESEvents;
IMPORT AESForms;
IMPORT AESMenus;
IMPORT AESGraphics;
IMPORT AESResources;
IMPORT AESWindows;
IMPORT Configuration;
IMPORT Resource;
IMPORT Screen;
IMPORT Event;
IMPORT Clock;
IMPORT Text;


CONST
   StackSize = 10000;

   Keyboard = 0;   (* Event Flags *)
   Button   = 1;
   Mouse1   = 2;
   Mouse2   = 3;
   Message  = 4;
   Timer    = 5;

   ResourceLoadFailed =
      "[3][ The DeskPac resource file | was not found. The DeskPac | tools are disabled. ][ OK ]";

   NoLowResLine1 = "[3][ DeskPac requires that the | screen be in either Medium |";
   NoLowResLine2 = " or High Resolution. The | DeskPac tools are disabled. ][ OK ]";

   DemoDoneLine1 = "[1][ The demo time has expired. | DeskPac Plus is available |";
   DemoDoneLine2 = " from: Computer Sorcery| 1851 Palm Bay Rd NE| Palm Bay, Florida 32905][ OK ]";

   Failed  = 0;
   Erase   = 0;
   Display = 1;

VAR
   Stack           : ARRAY [0..StackSize] OF CARDINAL;
   ExitButton      : INTEGER;
   AccessoryActive : BOOLEAN;
   MsgBuffer       : ARRAY [0..7] OF INTEGER;
   WhichEvent      : BITSET;
   MouseCoordinate : Screen.PixelCoordinate;
   MouseButton     : INTEGER;
   ModifierKey     : INTEGER;
   Key             : INTEGER;
   Clicks          : INTEGER;
   WindowId        : INTEGER;
   WhichMessage    : INTEGER;
   NotUsed         : INTEGER;
   Events          : INTEGER;
   CurrentTime     : CARDINAL;
   StartTime       : CARDINAL;
   Buffer          : ARRAY [0..180] OF CHAR;
   Success         : BOOLEAN;
   BadResource     : BOOLEAN;

BEGIN
   SETREG ( 15, ADR ( Stack[StackSize] ) );

   (*---- Initialize application --------------------------------------*)

   Resource.ApplicationId := AESApplications.ApplInitialise ();
   Event.AccessoryMenuId  := AESMenus.MenuRegister (
      Resource.ApplicationId, "  DeskPac Plus Demo " );
   Screen.Open ();
   Configuration.LoadDefault;

   (*---- Load the DeskPac resource file -------------------------------*)

   BadResource := FALSE;
   IF Screen.Resolution = Screen.LowRes THEN
      Text.Assign ( NoLowResLine1, Buffer );
      Success := Text.ConcatString ( Buffer, NoLowResLine2, Buffer );
      ExitButton      := AESForms.FormAlert ( 1, Buffer );
      AccessoryActive := FALSE;
      Events          := GEMAESbase.MesageEvent;
   ELSE
      IF Screen.Resolution = Screen.MediumRes THEN
         AESResources.ResourceLoad ( Configuration.ColorResource );
      ELSE
         AESResources.ResourceLoad ( Configuration.MonochromeResource );
      END;
      IF GEMAESbase.AESCallResult = Failed THEN
         BadResource     := TRUE;
         ExitButton      := AESForms.FormAlert ( 1, ResourceLoadFailed );
         AccessoryActive := FALSE;
         Events          := GEMAESbase.MesageEvent;
      ELSE
         AccessoryActive := TRUE; 
         Events          :=
            GEMAESbase.KeyboardEvent +
            GEMAESbase.ButtonEvent +
            GEMAESbase.MesageEvent +
            GEMAESbase.TimerEvent;
         Event.Initialize;
      END;
   END;

   (*---- Process events from the user --------------------------------*)

   GEMDOS.GetTime ( StartTime );
   AESGraphics.GrafMouse ( GEMAESbase.Arrow, NIL );
   LOOP
      WhichEvent := BITSET (AESEvents.EventMultiple (
         Events, 
         2,             (* Clicks                          *)
         1,             (* Monitor Left Mouse Button       *)
         1,             (* Wait for key pressed            *)
         0, 0, 0, 0, 0, (* Ignore Mouse Box1               *)
         0, 0, 0, 0, 0, (* Ignore Mouse Box2               *)
         ADR (MsgBuffer),
         Clock.TimerResolution, 0,
         MouseCoordinate.X,
         MouseCoordinate.Y,
         MouseButton,
         ModifierKey,
         Key,
         Clicks ));

      AESWindows.WindowUpdate ( GEMAESbase.BeginUpdate );
      AESWindows.WindowGet (
         0,
         GEMAESbase.Top,
         WindowId,
         NotUsed, NotUsed, NotUsed );

      IF AccessoryActive THEN
         Event.ProcessTimer;

         GEMDOS.GetTime ( CurrentTime );
         IF (CurrentTime - StartTime) > 160 THEN  (* 5 minutes *)
            Buffer  := DemoDoneLine1;
            Success := Text.ConcatString (
               Buffer, DemoDoneLine2, Buffer );
            ExitButton := AESForms.FormAlert ( 1, Buffer );
            AccessoryActive := FALSE;
         END;
      END;
        
      IF Message IN WhichEvent THEN
         IF AccessoryActive THEN
            WindowId := MsgBuffer [3];
            Event.ProcessMessage ( WindowId, MsgBuffer );
         ELSIF MsgBuffer[0] = GEMAESbase.AccessoryClose THEN
            (* Ignore the event *)
         ELSIF BadResource THEN
            ExitButton := AESForms.FormAlert ( 1, ResourceLoadFailed );
         ELSE
            Buffer  := DemoDoneLine1;
            Success := Text.ConcatString (
               Buffer, DemoDoneLine2, Buffer );
            ExitButton := AESForms.FormAlert ( 1, Buffer );
         END;
      END;

      IF Button IN WhichEvent THEN
         IF AccessoryActive THEN
            Event.ProcessButton ( WindowId, MouseButton, ModifierKey, Clicks );
         END;
      END;

      IF Keyboard IN WhichEvent THEN
         IF AccessoryActive THEN
            Event.ProcessKey ( WindowId, Key, ModifierKey );
         END;
      END;

      AESWindows.WindowUpdate ( GEMAESbase.EndUpdate );

   END (* LOOP *);
END DeskPac.

