IMPLEMENTATION MODULE FileName;


   IMPORT Text;
   IMPORT GEMDOS;


   (********************************************************************)

   PROCEDURE BuildFileName (
      VAR Directory    : (* IN *)  ARRAY OF CHAR;
      VAR FileNameBody : (* IN *)  ARRAY OF CHAR;
      VAR FullFileName : (* OUT *) ARRAY OF CHAR );

   VAR
      Index   : CARDINAL;
      Ch      : CHAR;
      Success : BOOLEAN;

   BEGIN
      Index := Text.Length ( Directory );
      IF Index = 0 THEN
         Text.Assign ( FileNameBody, FullFileName );
      ELSE

         (*--- Find last backslash in directory name ------------------*)

         LOOP
            DEC (Index);
            Ch := Directory[Index];
            IF (Index = 0) OR (Ch = '\') OR (Ch = ':') THEN
               EXIT;
            END;
         END;

         (*--- Copy over the rest of the filename ---------------------*)

         Success := Text.SliceString ( Directory, 0, Index, FullFileName );
         Success := Text.ConcatString ( FullFileName, FileNameBody, FullFileName );
      END;
   END BuildFileName;

   (********************************************************************)

   PROCEDURE GetDirectory (
      VAR FullFileName : (* IN *)  ARRAY OF CHAR;
      VAR Directory    : (* OUT *) ARRAY OF CHAR );

   VAR
      Length  : CARDINAL;
      Index   : CARDINAL;
      Stop    : INTEGER;

   BEGIN
      Length := Text.Length ( FullFileName );
      IF Length = 0 THEN
         Directory[0] := CHR (0);
      ELSE
         Index := 0;
         Stop  := -1;
         WHILE Index < (Length-1) DO
            IF FullFileName[Index] = ':' THEN
               Stop := Index;
            ELSIF FullFileName[Index] = '\' THEN
               Stop := Index-1;
            END;
            INC (Index);
         END (* DO *);
         IF Stop < 0 THEN
           Directory := "";
         ELSE
           IF NOT Text.SliceString ( FullFileName, 0, Stop, Directory ) THEN
             Directory[0] := CHR (0);
           END;
         END;
      END;
   END GetDirectory;

   (********************************************************************)

   PROCEDURE GetFileName (
      VAR FullFileName : (* IN *)  ARRAY OF CHAR;
      VAR FileNameBody : (* OUT *) ARRAY OF CHAR );

   VAR
      Length  : CARDINAL;
      Index   : CARDINAL;
      Start   : CARDINAL;
      Stop    : CARDINAL;
      Ch      : CHAR;

   BEGIN
      Length := Text.Length ( FullFileName );
      IF Length = 0 THEN
         FileNameBody[0] := CHR (0);
      ELSE
         Index := 0;
         Start := 0;
         Stop  := Length;
         LOOP
            Ch := FullFileName[Index];
            IF Ch = ':' THEN
               Start := Index + 1;
            ELSIF Ch = '\' THEN
               Start := Index + 1;
            ELSIF Ch = '.' THEN
               Stop := Index - 1;
            END;
            INC (Index);
            IF Index >= Length THEN
               EXIT;
            END;
         END (* LOOP *);
         IF NOT Text.SliceString ( FullFileName, Start, Stop, FileNameBody ) THEN
           FileNameBody[0] := CHR (0);
         END;
      END;
   END GetFileName;

   (********************************************************************)

   PROCEDURE GetExtension (
      VAR FullFileName : (* IN *)  ARRAY OF CHAR;
      VAR Extension    : (* OUT *) ARRAY OF CHAR );

   VAR
      Length  : CARDINAL;
      Index   : CARDINAL;

   BEGIN
      Length := Text.Length ( FullFileName );
      IF Length = 0 THEN
         Extension[0] := CHR (0);
      ELSE
         Index := Length;
         LOOP
            DEC (Index);
            IF (Index = 0) OR (FullFileName[Index] = '.') THEN
               EXIT;
            END;
         END (* LOOP *);
         IF NOT Text.SliceString ( FullFileName, Index + 1, Length - 1, Extension ) THEN
            Extension[0] := CHR (0);
         END;
      END;
   END GetExtension;

   (********************************************************************)

   PROCEDURE Exists ( VAR File : (* IN *) ARRAY OF CHAR ) : BOOLEAN;

   CONST Read = 0;

   VAR
      FileHandle : INTEGER;
      FileStatus : INTEGER;
      Success    : BOOLEAN;

   BEGIN
      GEMDOS.Open ( File, Read, FileHandle );
      IF FileHandle < GEMDOS.EOK THEN
         RETURN (FALSE);
      ELSE
         Success := GEMDOS.Close ( FileHandle );
         RETURN (TRUE);
      END;
   END Exists;


END FileName.


