IMPLEMENTATION MODULE Icon;


   (*$S-,$T- turn off stack and range checking *) 

   FROM SYSTEM IMPORT ADR, ADDRESS;
   IMPORT GEMAESbase;
   IMPORT AESObjects;
   IMPORT AESResources;
   IMPORT Screen;


   (********************************************************************)

   PROCEDURE GetAddress ( ObjectTree  : INTEGER;
                          ObjectIndex : INTEGER ) : ObjectPtr;

   VAR TreeAddress : POINTER TO ARRAY [0..1000] OF Object;

   BEGIN
      AESResources.ResourceGetAddr (
         GEMAESbase.RTree, ObjectTree, TreeAddress );
      RETURN ADR (TreeAddress^[ObjectIndex]);
   END GetAddress;

   (********************************************************************)

   PROCEDURE GetRegion ( Tree       : INTEGER;
                         Object     : INTEGER;
                         VAR Region : Screen.Box );

   VAR
      TreeAddr : ADDRESS;
      Item     : ObjectPtr;

   BEGIN
      AESResources.ResourceGetAddr ( GEMAESbase.RTree, Tree, TreeAddr );
      Item := GetAddress ( Tree, Object );
      Region.Size.Width  := Item^.Width;
      Region.Size.Height := Item^.Height;
      AESObjects.ObjectOffset ( TreeAddr, Object, Region.Origin.X, Region.Origin.Y );
   END GetRegion;

   (********************************************************************)

   PROCEDURE SetOrigin ( Tree   : INTEGER;
                         Object : INTEGER;
                         Origin : Screen.PixelCoordinate );

   VAR Item      : ObjectPtr;

   BEGIN
      Item := GetAddress ( Tree, Object );
      Item^.X := Origin.X;
      Item^.Y := Origin.Y;
   END SetOrigin;

   (********************************************************************)

   PROCEDURE SetSize ( Tree    : INTEGER;
                       Object  : INTEGER;
                       NewSize : Screen.Area );

   VAR Item : ObjectPtr;

   BEGIN
      Item := GetAddress ( Tree, Object );
      Item^.Width  := NewSize.Width;
      Item^.Height := NewSize.Height;
   END SetSize;

   (********************************************************************)

   PROCEDURE Enable (
      Tree    : (* IN *) INTEGER;
      Object  : (* IN *) INTEGER;
      ClipBox : (* IN *) Screen.Box );

   VAR ItemPtr : ObjectPtr;

   BEGIN
      ItemPtr := GetAddress ( Tree, Object );
      IF Disabled IN ItemPtr^.State THEN
         ItemPtr^.State := ItemPtr^.State - {Disabled};
         Display ( Tree, Object, ClipBox );
      END;
   END Enable;

   (********************************************************************)

   PROCEDURE Disable (
      Tree    : (* IN *) INTEGER;
      Object  : (* IN *) INTEGER;
      ClipBox : (* IN *) Screen.Box );

   VAR ItemPtr : ObjectPtr;

   BEGIN
      ItemPtr := GetAddress ( Tree, Object );
      IF NOT (Disabled IN ItemPtr^.State) THEN
         ItemPtr^.State := ItemPtr^.State + {Disabled};
         Display ( Tree, Object, ClipBox );
      END;
   END Disable;

   (********************************************************************)

   PROCEDURE Select (
      Tree    : (* IN *) INTEGER;
      Object  : (* IN *) INTEGER;
      ClipBox : (* IN *) Screen.Box );

   VAR ItemPtr : ObjectPtr;

   BEGIN
      ItemPtr := GetAddress ( Tree, Object );
      IF NOT (Selected IN ItemPtr^.State) THEN
         ItemPtr^.State := ItemPtr^.State + {Selected};
         Display ( Tree, Object, ClipBox );
      END;
   END Select;

   (********************************************************************)

   PROCEDURE Deselect (
      Tree    : (* IN *) INTEGER;
      Object  : (* IN *) INTEGER;
      ClipBox : (* IN *) Screen.Box );

   VAR ItemPtr : ObjectPtr;

   BEGIN
      ItemPtr := GetAddress ( Tree, Object );
      IF Selected IN ItemPtr^.State THEN
         ItemPtr^.State := ItemPtr^.State - {Selected};
         Display ( Tree, Object, ClipBox );
      END;
   END Deselect;

   (********************************************************************)

   PROCEDURE Find ( Tree            : INTEGER;
                    MouseCoordinate : Screen.PixelCoordinate;
                    VAR Object      : INTEGER ) : BOOLEAN;

   VAR TreeAddress : ADDRESS;

   BEGIN
      AESResources.ResourceGetAddr ( GEMAESbase.RTree, Tree, TreeAddress );
      Object := AESObjects.ObjectFind (
         TreeAddress, 0,
         100,
         MouseCoordinate.X,
         MouseCoordinate.Y );    
      RETURN (Object >= 0);
   END Find;

   (********************************************************************)

   PROCEDURE Display ( Tree    : INTEGER;
                       Object  : INTEGER;
                       ClipBox : Screen.Box );

   VAR TreeAddress : ADDRESS;

   BEGIN
      AESResources.ResourceGetAddr ( GEMAESbase.RTree, Tree, TreeAddress );
      AESObjects.ObjectDraw (
         TreeAddress,
         Object,
         100,
         ClipBox.Origin.X,
         ClipBox.Origin.Y, 
         ClipBox.Size.Width,
         ClipBox.Size.Height );    
   END Display;


END Icon.

