IMPLEMENTATION MODULE Menu;

FROM SYSTEM IMPORT ADR, ADDRESS;
IMPORT GEMAESbase;
IMPORT AESEvents;
IMPORT AESForms;
IMPORT AESGraphics;
IMPORT AESObjects;
IMPORT AESResources;
IMPORT AESWindows;
IMPORT Icon;
IMPORT Screen;

CONST EdgeWidth = 5;

VAR MenuPtr : Icon.ObjectPtr;

(***********************************************************************)

PROCEDURE Display ( MenuId : INTEGER ) : INTEGER;

CONST
  NoItem      = -1;
  Redraw      =  1;
  DoNotRedraw =  0;
  Button      =  1;

VAR
  MsgBuffer       : ARRAY [0..7] OF INTEGER;
  WhichEvent      : BITSET;
  MenuAddress     : ADDRESS;
  MenuItem        : INTEGER;
  NewItem         : INTEGER;
  ItemPtr         : Icon.ObjectPtr;
  MouseCoordinate : Screen.PixelCoordinate;
  MouseState      : INTEGER;
  RectangleFlag   : INTEGER;
  Rectangle       : Screen.Box;
  KeyboardState   : INTEGER;
  Key             : INTEGER;
  Clicks          : INTEGER;
  Unused          : INTEGER;

BEGIN
  AESResources.ResourceGetAddr (
      GEMAESbase.RTree, MenuId, MenuAddress );
  MenuPtr := Icon.GetAddress ( MenuId, 0 );
  AESForms.FormDialogue (
      GEMAESbase.FormStart,
      0, 0, 0, 0,
      MenuPtr^.X - EdgeWidth,
      MenuPtr^.Y - EdgeWidth,
      MenuPtr^.Width + EdgeWidth * 2,
      MenuPtr^.Height + EdgeWidth * 2 );
  AESObjects.ObjectDraw (
      MenuAddress,
      0, 10,
      MenuPtr^.X - EdgeWidth,
      MenuPtr^.Y - EdgeWidth,
      MenuPtr^.Width + EdgeWidth * 2,
      MenuPtr^.Height + EdgeWidth * 2 );

  (* Interact with the menu *)

  AESWindows.WindowUpdate ( GEMAESbase.BeginMouseControl );
  MenuItem := NoItem;
  AESGraphics.GrafMouseKeyboardState (
      MouseCoordinate.X,
      MouseCoordinate.Y,
      MouseState,
      KeyboardState );
  LOOP
    NewItem := AESObjects.ObjectFind (
        MenuAddress, 0, 10, MouseCoordinate.X, MouseCoordinate.Y );
    IF NewItem <> MenuItem THEN
      IF MenuItem >= 0 THEN
        AESObjects.ObjectChange (
            MenuAddress,
            MenuItem,
            0,
            MenuPtr^.X,
            MenuPtr^.Y,
            MenuPtr^.Width,
            MenuPtr^.Height,
            GEMAESbase.Normal,
            Redraw );
      END;
      IF NewItem >= 0 THEN
        AESObjects.ObjectChange (
            MenuAddress,
            NewItem,
            0,
            MenuPtr^.X,
            MenuPtr^.Y,
            MenuPtr^.Width,
            MenuPtr^.Height,
            GEMAESbase.Selected,
            Redraw );
      END;
      MenuItem := NewItem;
    END;
    IF MenuItem < 0 THEN
      ItemPtr       := Icon.GetAddress ( MenuId, 0 );
      RectangleFlag := 0;
    ELSE
      ItemPtr       := Icon.GetAddress ( MenuId, MenuItem );
      RectangleFlag := 1;
    END;
    Rectangle.Origin.X    := ItemPtr^.X;
    Rectangle.Origin.Y    := ItemPtr^.Y;
    Rectangle.Size.Width  := ItemPtr^.Width;
    Rectangle.Size.Height := ItemPtr^.Height;
    WhichEvent := BITSET (AESEvents.EventMultiple (
        GEMAESbase.Mouse1Event + GEMAESbase.ButtonEvent, 
        1,             (* Clicks                    *)
        1,             (* Monitor Left Mouse Button *)
        1,             (* Wait for key pressed      *)
        RectangleFlag,
        Rectangle.Origin.X,
        Rectangle.Origin.Y,
        Rectangle.Size.Width,
        Rectangle.Size.Height,
        0, 0, 0, 0, 0, (* Ignore Mouse Box2 *)
        ADR (MsgBuffer),
        0, 0,
        MouseCoordinate.X,
        MouseCoordinate.Y,
        MouseState,
        KeyboardState,
        Key,
        Clicks ));
    IF Button IN WhichEvent THEN
      EXIT;
    END;
  END (* LOOP *);
  Unused := AESEvents.EventButton (
      1, 1, 0,
      MouseCoordinate.X,
      MouseCoordinate.Y,
      MouseState,
      KeyboardState );
  IF MenuItem >= 0 THEN
    AESObjects.ObjectChange (
        MenuAddress,
        MenuItem,
        0,
        MenuPtr^.X,
        MenuPtr^.Y,
        MenuPtr^.Width,
        MenuPtr^.Height,
        GEMAESbase.Normal,
        DoNotRedraw );
  END;
  RETURN (MenuItem);
END Display;

(***********************************************************************)

PROCEDURE Remove;

BEGIN
  AESWindows.WindowUpdate ( GEMAESbase.EndMouseControl );
  AESForms.FormDialogue (
      GEMAESbase.FormFinish,
      0, 0, 0, 0,
      MenuPtr^.X - EdgeWidth,
      MenuPtr^.Y - EdgeWidth,
      MenuPtr^.Width + EdgeWidth * 2,
      MenuPtr^.Height + EdgeWidth * 2 );
END Remove;


END Menu.
